diff -r -u -H -N gcc-2.6.3/cp/parse.c gcc-i2.6.3/cp/parse.c
--- gcc-2.6.3/cp/parse.c	Fri Oct 14 14:51:23 1994
+++ gcc-i2.6.3/cp/parse.c	Tue Dec 20 16:53:24 1994
@@ -7231,184 +7177,188 @@
 		  yychar = ')';
 		;
     break;}
+case 679:
+#line 3594 "parse.y"
+{ yyval.ttype = build_tree_list (NULL_TREE, yyval.ttype); ;
+    break;}
 case 680:
 #line 3596 "parse.y"
-{ yyval.ttype = build_tree_list (NULL_TREE, yyval.ttype); ;
+{ yyval.ttype = build_tree_list (yyvsp[0].ttype, yyval.ttype); ;
     break;}
 case 681:
 #line 3598 "parse.y"
-{ yyval.ttype = build_tree_list (yyvsp[0].ttype, yyval.ttype); ;
+{ yyval.ttype = chainon (yyval.ttype, yyvsp[0].ttype); ;
     break;}
 case 682:
 #line 3600 "parse.y"
-{ yyval.ttype = chainon (yyval.ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = chainon (yyval.ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); ;
     break;}
 case 683:
 #line 3602 "parse.y"
-{ yyval.ttype = chainon (yyval.ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); ;
-    break;}
-case 684:
-#line 3604 "parse.y"
 { yyval.ttype = chainon (yyval.ttype, build_tree_list (yyvsp[0].ttype, yyvsp[-2].ttype)); ;
     break;}
-case 686:
-#line 3610 "parse.y"
+case 685:
+#line 3608 "parse.y"
 { yyval.ttype = build_tree_list (NULL_TREE, yyval.ttype); ;
     break;}
+case 686:
+#line 3631 "parse.y"
+{ yyval.ttype = build_tree_list (yyval.ttype, yyvsp[0].ttype); ;
+    break;}
 case 687:
 #line 3633 "parse.y"
 { yyval.ttype = build_tree_list (yyval.ttype, yyvsp[0].ttype); ;
     break;}
 case 688:
 #line 3635 "parse.y"
-{ yyval.ttype = build_tree_list (yyval.ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = build_tree_list (get_decl_list (yyval.ttype), yyvsp[0].ttype); ;
     break;}
 case 689:
 #line 3637 "parse.y"
-{ yyval.ttype = build_tree_list (get_decl_list (yyval.ttype), yyvsp[0].ttype); ;
+{ yyval.ttype = build_tree_list (yyval.ttype, yyvsp[0].ttype); ;
     break;}
 case 690:
 #line 3639 "parse.y"
-{ yyval.ttype = build_tree_list (yyval.ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = build_tree_list (yyval.ttype, NULL_TREE); ;
     break;}
 case 691:
 #line 3641 "parse.y"
-{ yyval.ttype = build_tree_list (yyval.ttype, NULL_TREE); ;
+{ yyval.ttype = build_tree_list (yyval.ttype, yyvsp[0].ttype); ;
     break;}
 case 692:
-#line 3643 "parse.y"
-{ yyval.ttype = build_tree_list (yyval.ttype, yyvsp[0].ttype); ;
+#line 3646 "parse.y"
+{ yyval.ttype = build_tree_list (NULL_TREE, yyval.ttype); ;
     break;}
 case 693:
 #line 3648 "parse.y"
-{ yyval.ttype = build_tree_list (NULL_TREE, yyval.ttype); ;
-    break;}
-case 694:
-#line 3650 "parse.y"
 { yyval.ttype = build_tree_list (yyvsp[0].ttype, yyval.ttype); ;
     break;}
-case 697:
-#line 3659 "parse.y"
+case 696:
+#line 3657 "parse.y"
 { see_typename (); ;
     break;}
-case 698:
-#line 3682 "parse.y"
+case 697:
+#line 3680 "parse.y"
 {
 		  warning ("type specifier omitted for parameter");
 		  yyval.ttype = build_tree_list (TREE_PURPOSE (TREE_VALUE (yyvsp[-1].ttype)), NULL_TREE);
 		;
     break;}
-case 699:
-#line 3687 "parse.y"
+case 698:
+#line 3685 "parse.y"
 {
 		  warning ("type specifier omitted for parameter");
 		  yyval.ttype = build_tree_list (TREE_PURPOSE (TREE_VALUE (yyvsp[-2].ttype)), yyval.ttype);
 		;
     break;}
-case 700:
-#line 3695 "parse.y"
+case 699:
+#line 3693 "parse.y"
 { yyval.ttype = NULL_TREE; ;
     break;}
-case 701:
-#line 3697 "parse.y"
+case 700:
+#line 3695 "parse.y"
 { yyval.ttype = yyvsp[-1].ttype; ;
     break;}
-case 702:
-#line 3702 "parse.y"
+case 701:
+#line 3700 "parse.y"
 { yyval.ttype = build_decl_list (NULL_TREE, yyval.ttype); ;
     break;}
-case 704:
-#line 3708 "parse.y"
+case 703:
+#line 3706 "parse.y"
 {
 		  TREE_CHAIN (yyvsp[0].ttype) = yyval.ttype;
 		  yyval.ttype = yyvsp[0].ttype;
 		;
     break;}
+case 704:
+#line 3714 "parse.y"
+{ yyval.ttype = NULL_TREE; ;
+    break;}
 case 705:
 #line 3716 "parse.y"
-{ yyval.ttype = NULL_TREE; ;
+{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
     break;}
 case 706:
 #line 3718 "parse.y"
-{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = make_reference_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
     break;}
 case 707:
 #line 3720 "parse.y"
-{ yyval.ttype = make_reference_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
-    break;}
-case 708:
-#line 3722 "parse.y"
 { tree arg = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype);
 		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-2].ttype, arg);
 		;
     break;}
-case 709:
-#line 3728 "parse.y"
+case 708:
+#line 3726 "parse.y"
 { got_scope = NULL_TREE; ;
     break;}
+case 709:
+#line 3731 "parse.y"
+{ yyval.ttype = ansi_opname[MULT_EXPR]; ;
+    break;}
 case 710:
 #line 3733 "parse.y"
-{ yyval.ttype = ansi_opname[MULT_EXPR]; ;
+{ yyval.ttype = ansi_opname[TRUNC_DIV_EXPR]; ;
     break;}
 case 711:
 #line 3735 "parse.y"
-{ yyval.ttype = ansi_opname[TRUNC_DIV_EXPR]; ;
+{ yyval.ttype = ansi_opname[TRUNC_MOD_EXPR]; ;
     break;}
 case 712:
 #line 3737 "parse.y"
-{ yyval.ttype = ansi_opname[TRUNC_MOD_EXPR]; ;
+{ yyval.ttype = ansi_opname[PLUS_EXPR]; ;
     break;}
 case 713:
 #line 3739 "parse.y"
-{ yyval.ttype = ansi_opname[PLUS_EXPR]; ;
+{ yyval.ttype = ansi_opname[MINUS_EXPR]; ;
     break;}
 case 714:
 #line 3741 "parse.y"
-{ yyval.ttype = ansi_opname[MINUS_EXPR]; ;
+{ yyval.ttype = ansi_opname[BIT_AND_EXPR]; ;
     break;}
 case 715:
 #line 3743 "parse.y"
-{ yyval.ttype = ansi_opname[BIT_AND_EXPR]; ;
+{ yyval.ttype = ansi_opname[BIT_IOR_EXPR]; ;
     break;}
 case 716:
 #line 3745 "parse.y"
-{ yyval.ttype = ansi_opname[BIT_IOR_EXPR]; ;
+{ yyval.ttype = ansi_opname[BIT_XOR_EXPR]; ;
     break;}
 case 717:
 #line 3747 "parse.y"
-{ yyval.ttype = ansi_opname[BIT_XOR_EXPR]; ;
+{ yyval.ttype = ansi_opname[BIT_NOT_EXPR]; ;
     break;}
 case 718:
 #line 3749 "parse.y"
-{ yyval.ttype = ansi_opname[BIT_NOT_EXPR]; ;
+{ yyval.ttype = ansi_opname[COMPOUND_EXPR]; ;
     break;}
 case 719:
 #line 3751 "parse.y"
-{ yyval.ttype = ansi_opname[COMPOUND_EXPR]; ;
+{ yyval.ttype = ansi_opname[yyvsp[0].code]; ;
     break;}
 case 720:
 #line 3753 "parse.y"
-{ yyval.ttype = ansi_opname[yyvsp[0].code]; ;
+{ yyval.ttype = ansi_opname[LT_EXPR]; ;
     break;}
 case 721:
 #line 3755 "parse.y"
-{ yyval.ttype = ansi_opname[LT_EXPR]; ;
+{ yyval.ttype = ansi_opname[GT_EXPR]; ;
     break;}
 case 722:
 #line 3757 "parse.y"
-{ yyval.ttype = ansi_opname[GT_EXPR]; ;
+{ yyval.ttype = ansi_opname[yyvsp[0].code]; ;
     break;}
 case 723:
 #line 3759 "parse.y"
-{ yyval.ttype = ansi_opname[yyvsp[0].code]; ;
+{ yyval.ttype = ansi_assopname[yyvsp[0].code]; ;
     break;}
 case 724:
 #line 3761 "parse.y"
-{ yyval.ttype = ansi_assopname[yyvsp[0].code]; ;
+{ yyval.ttype = ansi_opname [MODIFY_EXPR]; ;
     break;}
 case 725:
 #line 3763 "parse.y"
-{ yyval.ttype = ansi_opname [MODIFY_EXPR]; ;
+{ yyval.ttype = ansi_opname[yyvsp[0].code]; ;
     break;}
 case 726:
 #line 3765 "parse.y"
@@ -7416,79 +7366,75 @@
     break;}
 case 727:
 #line 3767 "parse.y"
-{ yyval.ttype = ansi_opname[yyvsp[0].code]; ;
+{ yyval.ttype = ansi_opname[POSTINCREMENT_EXPR]; ;
     break;}
 case 728:
 #line 3769 "parse.y"
-{ yyval.ttype = ansi_opname[POSTINCREMENT_EXPR]; ;
+{ yyval.ttype = ansi_opname[PREDECREMENT_EXPR]; ;
     break;}
 case 729:
 #line 3771 "parse.y"
-{ yyval.ttype = ansi_opname[PREDECREMENT_EXPR]; ;
+{ yyval.ttype = ansi_opname[TRUTH_ANDIF_EXPR]; ;
     break;}
 case 730:
 #line 3773 "parse.y"
-{ yyval.ttype = ansi_opname[TRUTH_ANDIF_EXPR]; ;
+{ yyval.ttype = ansi_opname[TRUTH_ORIF_EXPR]; ;
     break;}
 case 731:
 #line 3775 "parse.y"
-{ yyval.ttype = ansi_opname[TRUTH_ORIF_EXPR]; ;
+{ yyval.ttype = ansi_opname[TRUTH_NOT_EXPR]; ;
     break;}
 case 732:
 #line 3777 "parse.y"
-{ yyval.ttype = ansi_opname[TRUTH_NOT_EXPR]; ;
+{ yyval.ttype = ansi_opname[COND_EXPR]; ;
     break;}
 case 733:
 #line 3779 "parse.y"
-{ yyval.ttype = ansi_opname[COND_EXPR]; ;
+{ yyval.ttype = ansi_opname[yyvsp[0].code]; ;
     break;}
 case 734:
 #line 3781 "parse.y"
-{ yyval.ttype = ansi_opname[yyvsp[0].code]; ;
+{ yyval.ttype = ansi_opname[COMPONENT_REF]; ;
     break;}
 case 735:
 #line 3783 "parse.y"
-{ yyval.ttype = ansi_opname[COMPONENT_REF]; ;
+{ yyval.ttype = ansi_opname[MEMBER_REF]; ;
     break;}
 case 736:
 #line 3785 "parse.y"
-{ yyval.ttype = ansi_opname[MEMBER_REF]; ;
+{ yyval.ttype = ansi_opname[CALL_EXPR]; ;
     break;}
 case 737:
 #line 3787 "parse.y"
-{ yyval.ttype = ansi_opname[CALL_EXPR]; ;
+{ yyval.ttype = ansi_opname[ARRAY_REF]; ;
     break;}
 case 738:
 #line 3789 "parse.y"
-{ yyval.ttype = ansi_opname[ARRAY_REF]; ;
+{ yyval.ttype = ansi_opname[NEW_EXPR]; ;
     break;}
 case 739:
 #line 3791 "parse.y"
-{ yyval.ttype = ansi_opname[NEW_EXPR]; ;
+{ yyval.ttype = ansi_opname[DELETE_EXPR]; ;
     break;}
 case 740:
 #line 3793 "parse.y"
-{ yyval.ttype = ansi_opname[DELETE_EXPR]; ;
+{ yyval.ttype = ansi_opname[VEC_NEW_EXPR]; ;
     break;}
 case 741:
 #line 3795 "parse.y"
-{ yyval.ttype = ansi_opname[VEC_NEW_EXPR]; ;
+{ yyval.ttype = ansi_opname[VEC_DELETE_EXPR]; ;
     break;}
 case 742:
-#line 3797 "parse.y"
-{ yyval.ttype = ansi_opname[VEC_DELETE_EXPR]; ;
+#line 3798 "parse.y"
+{ yyval.ttype = grokoptypename (yyvsp[-1].ttype, yyvsp[0].ttype); ;
     break;}
 case 743:
 #line 3800 "parse.y"
-{ yyval.ttype = grokoptypename (yyvsp[-1].ttype, yyvsp[0].ttype); ;
-    break;}
-case 744:
-#line 3802 "parse.y"
 { yyval.ttype = ansi_opname[ERROR_MARK]; ;
     break;}
 }
    /* the action file gets copied in in place of this dollarsign */
-#line 480 "/usr/local/lib/bison.simple"
+#line 465 "/usr/local/lib/bison.simple"
 
   yyvsp -= yylen;
   yyssp -= yylen;
@@ -7684,7 +7630,7 @@
   yystate = yyn;
   goto yynewstate;
 }
-#line 3805 "parse.y"
+#line 3803 "parse.y"
 
 
 #ifdef SPEW_DEBUG
diff -r -u -H -N gcc-2.6.3/cse.c gcc-i2.6.3/cse.c
--- gcc-2.6.3/cse.c	Tue Nov  1 18:38:40 1994
+++ gcc-i2.6.3/cse.c	Thu Feb 16 11:58:55 1995
@@ -6007,6 +6007,29 @@
       sets = (struct set *) alloca (sizeof (struct set));
       sets[0].rtl = x;
 
+/* intel1 */
+#ifdef STACK_REGS
+#ifdef IS_STACK_MODE
+      if (IS_STACK_MODE (DFmode) && GET_CODE (SET_SRC (x)) == CONST_DOUBLE 
+         && GET_CODE (SET_DEST (x)) == REG)
+        {
+           /* not worthwhile to hold on stack */
+	  rtx tem = find_reg_note (insn, REG_EQUAL, 0);
+	  
+	  /* Record the actual constant value in a REG_EQUAL note, making
+	     a new one if one does not already exist.  */
+	  if (tem)
+	    XEXP (tem, 0) = SET_SRC(x);
+	  else
+	    REG_NOTES (insn) = gen_rtx (EXPR_LIST, REG_EQUAL,
+				        SET_SRC(x), REG_NOTES (insn));
+
+	  invalidate (SET_DEST (x), GET_MODE(x) );
+        }
+      else
+      
+#endif
+#endif
       /* Ignore SETs that are unconditional jumps.
 	 They never need cse processing, so this does not hurt.
 	 The reason is not efficiency but rather
@@ -6625,6 +6648,32 @@
       if (dest == pc_rtx && src_const && GET_CODE (src_const) == LABEL_REF)
 	src_folded = src_const, src_folded_cost = -1;
 	  
+#ifdef SAVE_ON_REGS
+      /* intel1 If src is of form  (reg1 OP const) and src_folded
+         is of form (reg2 OP const) and the costs are the same
+         and reg1 != reg2,
+         then bump up the cost of src_folded so that src will be
+         preferred.  The reason for this is that if reg2 is used
+         here it's life may be extended thereby increasing register
+         pressure and causing superfulous movs.  */
+      {
+        char * fmt;
+        if (src)
+          fmt = GET_RTX_FORMAT (GET_CODE (src));
+        if (src && src_folded && src_cost == src_folded_cost
+            && GET_CODE (src) == GET_CODE (src_folded) 
+            && GET_RTX_LENGTH (GET_CODE (src)) == 2
+            && fmt[0] == 'e' && fmt[1] == 'e'
+            && GET_CODE (XEXP (src, 0)) == REG
+            && GET_CODE (XEXP (src, 1)) == CONST_INT 
+            && GET_CODE (XEXP (src_folded, 0)) == REG
+            && GET_CODE (XEXP (src_folded, 1)) == CONST_INT 
+            && !rtx_equal_p (XEXP (src, 0), XEXP (src_folded, 0)))
+          {
+            src_folded_cost++;
+          }          
+      }
+#endif
       /* Terminate loop when replacement made.  This must terminate since
          the current contents will be tested and will always be valid.  */
       while (1)
@@ -7068,6 +7117,16 @@
 	    if (sets[i].src_elt == 0)
 	      {
 		register struct table_elt *elt;
+		/* intel1 */
+		int do_rehash=0;
+
+                /* intel1 */
+		if(GET_CODE(src)==REG && 
+		   !REGNO_QTY_VALID_P (REGNO(src)))
+		    { /* we will want to rehash all expressions based of src since
+		         reg_qty[REGNO(src)] is about to change */
+		      do_rehash = 1;
+		    }
 
 		/* Note that these insert_regs calls cannot remove
 		   any of the src_elt's, because they would have failed to
diff -r -u -H -N gcc-2.6.3/expr.c gcc-i2.6.3/expr.c
--- gcc-2.6.3/expr.c	Wed Nov 30 19:08:49 1994
+++ gcc-i2.6.3/expr.c	Wed Feb 15 23:19:22 1995
@@ -23,6 +23,8 @@
 #include "rtl.h"
 #include "tree.h"
 #include "obstack.h"
+/* intel1 */
+#include "c-tree.h"
 #include "flags.h"
 #include "regs.h"
 #include "function.h"
@@ -8596,6 +8598,12 @@
 	  && (i = floor_log2 (TREE_INT_CST_LOW (TREE_OPERAND (exp, 1)))) >= 0
 	  && (mode = mode_for_size (i + 1, MODE_INT, 0)) != BLKmode
 	  && (type = type_for_mode (mode, 1)) != 0
+      /* intel1 */
+      && !(SLOW_SHORT_ACCESS
+         && (type == short_unsigned_type_node
+             || type == short_integer_type_node
+             || type == intHI_type_node
+             || type == unsigned_intHI_type_node))
 	  && TYPE_PRECISION (type) < TYPE_PRECISION (TREE_TYPE (exp))
 	  && (cmp_optab->handlers[(int) TYPE_MODE (type)].insn_code
 	      != CODE_FOR_nothing))
@@ -8751,6 +8759,12 @@
 	type = type_for_size (bitsize, unsignedp);
 	if (! SLOW_BYTE_ACCESS
 	    && type != 0 && bitsize >= 0
+	    /* intel1 */
+	    && !(SLOW_SHORT_ACCESS 
+	         && (type == short_unsigned_type_node 
+	             || type == short_integer_type_node
+	             || type == intHI_type_node 
+	             || type == unsigned_intHI_type_node))
 	    && TYPE_PRECISION (type) < TYPE_PRECISION (TREE_TYPE (exp))
 	    && (cmp_optab->handlers[(int) TYPE_MODE (type)].insn_code
 		!= CODE_FOR_nothing))
diff -r -u -H -N gcc-2.6.3/flags.h gcc-i2.6.3/flags.h
--- gcc-2.6.3/flags.h	Thu May 12 20:04:27 1994
+++ gcc-i2.6.3/flags.h	Wed Feb 15 22:47:02 1995
@@ -357,3 +357,149 @@
    function.  */
 
 extern int current_function_has_nonlocal_goto;
+
+/* intel1 our optimization controllers */
+
+/* Optimize usage of registers for memory addresses */
+
+extern int flag_opt_reg_use;
+
+/* Do reduce all the mem address givs */
+
+extern int flag_all_mem_givs;
+
+/* Try to treat index terms of addresses as reducible mem givs */
+
+extern int flag_reduce_index_givs;
+
+/* After reload try to replace spill slots with equivalent registers */
+
+extern int flag_peep_spills;
+
+/* After reload try to optimize usage of spill slots in loops */
+
+extern int flag_loop_after_global;
+
+/* In optimization of loops treats jumps backwards as not nullifying
+   optimization opportunities.  */
+   
+extern int flag_jump_back;
+
+/* Do loop copy propogation */
+
+extern int flag_copy_prop;
+
+/* Do compare elimination */
+
+extern int flag_compare_elim;
+
+/* Do a mini software pipelining on stack registers */
+
+extern int flag_sftwr_pipe;
+
+/* Try aggressive changing of jumps taken to jumps not taken */
+
+extern int flag_opt_jumps_out;
+
+/* Try to replace memory operands with equivalent registers in first
+   pass of loop optimize */
+   
+extern int flag_replace_mem;
+
+/* Try to replace memory operands with equivalent stack registers in first
+   pass of loop optimize */
+   
+extern int flag_replace_stack_mem;
+
+/* After reload if a register is marked dead at a copy into another
+   register - see if the other register can be used in the first place.
+   Thereby eleiminating the copy.  */
+   
+extern int flag_reg_reg_copy_opt;
+
+/* Move stack registers that will be compared for equality off, the
+   stack before the comparison.  */
+   
+extern int flag_do_offload;
+
+/* Optimize usage of stack registers from the stack */
+
+extern int flag_opt_reg_stack;
+
+/* cse is sometimes detrimental - see flow.c */
+
+extern int flag_correct_cse_mistakes;
+
+/* Try to push loads back into loops if the loaded register has been spilled */
+
+extern int flag_push_load_into_loop;
+
+/* After reload use available registers to load memory operands into
+  them and use the register instead of the memory operand.  */
+  
+extern int flag_risc;
+
+/* After reload use available registers to load CONST_INTs into
+  them and then store the register instead of the CONST_INT.  */
+  
+extern int flag_risc_const;
+
+/* Allow scheduler to try to swap two instructions when the
+   first increments a register by a constant and the second
+   uses that register as a base
+*/
+
+extern int flag_swap_for_agi;
+
+/* A destination that was riscified should stay that way.  */
+
+extern int flag_risc_mem_dest;
+
+/* Try to use available registers so that a memory operand that is
+   reloaded will be reloaded into the same register.  This helps
+   loop_after_global.  */
+   
+extern int flag_replace_reload_regs;
+
+/* If the riscified instruction has not changed it's place in
+  scheduling then recombine it into a cisc instruction.  */
+  
+extern int flag_recombine;
+
+/* These negative flags needed to override optimization
+   levels which turn them on by default */
+   
+extern int flag_no_omit_frame_pointer;
+extern int flag_no_risc;
+extern int flag_no_risc_const;
+extern int flag_no_risc_mem_dest;
+extern int flag_no_recombine;
+/* Use the first pass of the scheduler to rearrange between
+   insns that reference stack registers.  */
+   
+extern int flag_schedule_stack_reg_insns;
+
+/* Use the first pass of the scheduler to rearrange between
+   insns that reference stack registers and those that don't
+   but not amongst themselves  */
+   
+extern int flag_interleave_stack_non_stack;
+
+/* These negative flags needed to override optimization
+   levels which turn them on by default */
+   
+extern int flag_no_schedule_stack_reg_insns;
+extern int flag_no_interleave_stack_non_stack;
+
+extern int flag_sign_extension_elim;
+
+/* Try to lift memory disambiguated memory operands that are stored
+   to in a loop into a register for the duration of the loop.  */
+   
+extern int flag_lift_stores;
+
+/* As above but do the disambiguation at runtime. i.e. there
+   will be two copies of the loop, one disambiguated one not,
+   And the decision of which one to run will be made at runtime.  */
+   
+extern int flag_runtime_lift_stores;
